#!/bin/bash
#Eshel Faraggi - RIS, LLC (C) 2017,2018

echo "
Eshel Faraggi, efaraggi@gmail.com
Research and Information Systems, LLC

Please cite: 
Faraggi et al. \"Simulated real-time deployment 
of a reoptimized UNRES scoring function\".
"

if [ ! -d unres/el/ ] ; then
  echo Cannot find UNRES, aborting. Make sure to run from Server2017/ directory
  exit
fi
fl=wei.el.list
if [ ! -s "$fl" ] ; then 
  for nm in `ls wei.el/*` ; do echo "\""`readlink -f $nm`"\""; done > $fl
fi
fl=wei.gb.list
if [ ! -s "$fl" ] ; then 
  for nm in `ls wei.gb/*` ; do echo "\""`readlink -f $nm`"\""; done > $fl
fi

hpwd=$PWD
pdb=$1
predir=$pdb.ounres
if [ -d $predir ] ; then 
  echo $predir exists, aborting. Remove/rename to run again.
  exit
fi

mkdir $predir
cp $pdb unres/el/input.pdb
cd $hpwd/unres/el
./unres.csh
el=input_GB.stat
for nm in `cat $el` ; do echo $nm ; done | awk '{if ($1+0 == $1) print $1}' | awk '{a=$NF; if (a<-11111) a=-11111; if (a>11111) a=11111; if (a!=a+0) a=11111; print a}' > $el.n
rm input.out_GB
meanfilesnorm.single $el.n list.good041116.mean.el
mv $el.n.zs $hpwd/$predir/unres.el2.n.zs
mv $el $hpwd/$predir/unres.out

cd $hpwd
cp $pdb unres/gb/input.pdb
cd $hpwd/unres/gb
./unres.csh 
el=input_GB.stat
for nm in `cat $el` ; do echo $nm ; done | awk '{if ($1+0 == $1) print $1}' | awk '{a=$NF; if (a<-11111) a=-11111; if (a>11111) a=11111; if (a!=a+0) a=11111; print a}' > $el.n
rm input.out_GB
meanfilesnorm.single $el.n list.good041116.mean.gb
mv $el.n.zs $hpwd/$predir/unres.gb2.n.zs
mv $el $hpwd/$predir/unres.out

cd $hpwd

fl=$pdb.length
la=`grep ATOM $pdb | wc -l` ; echo $la > $fl
l=`grep ATOM $pdb | awk '{print substr($0,22,10)}' | sort -u | wc -l`
echo $l >> $fl
meanfilesnorm.single $fl mean-std_pdb.length
mv $fl.zs $predir/length.zs
rm $fl
echo 0.0 > $predir/tms

genn2inst.e -d . -pr1 $predir -aw wei.el.list > $predir/gennout
cat $predir/gennout
ptms=`awk '{print (1.0-$2)/2.0}' $predir/gennout`
ptmssd=`awk '{print $3/2.0}' $predir/gennout`
echo "Predicted TMS of your model to native: $ptms, Standard Deviation over nn-ensemble: $ptmssd" >> $predir/ounres.prediction
echo -------------------------------------
echo
echo Predicted TMS of your model to native: $ptms
echo Standard Deviation over nn-ensemble: $ptmssd
echo
echo -------------------------------------

echo Thank you for using OUNRES!
echo "Please cite: 
Faraggi et al. \"Simulated real-time deployment 
of a reoptimized UNRES scoring function\"."
echo "
Eshel Faraggi, efaraggi@gmail.com
Research and Information Systems, LLC"
